#!/bin/tcsh -f

if ( $#argv < 4 ) then
    echo usage:$0 'Nevent (1mm|2mm) (1-120mev|100-520mev|500-2000mev) run#(00-99)'
    exit 1
endif

set nev   = $1
set thick = $2
set mom   = $3
set runno = $4

set rindex = `expr $runno + 1`

#set INPUTDIR  = /:/.rw/hpss/ps/klea/montecarlo/collimator6/open
#set INPUTDIR  = . 
set OUTPUTDIR = /:/.rw/hpss/ps/klea/montecarlo/barrelveto/2002_03/e391/${thick}/${mom}
#set OUTPUTDIR = .
set LOGDIR    = ./log/${thick}/${mom}

set oname = cbar_r${runno}

### dump
echo 'run   =' ${runno}
echo 'nevent=' ${nev}
echo ''
echo 'OutputFiles:'
echo ${OUTPUTDIR}/${oname}.hbook
echo ${LOGDIR}/${oname}.log
echo ''
#echo 'InputFile(s):'
#ls ${INPUTDIR}/r${runno}.hbook

#usage: gsim [-ohpss] [-ohid h] [-otitle Title] [-o ofile]
#            [-save mode(0:all 1:decayed)]
#            [-psfile psfile] [-display]
#            [-gen Nevent Nskip] [-rindex Index] [-rseeds seed1 seed2]
#            [-ihpss] [-ihid h]
#            [ -i inputfile [Nevent Nskip Nloop] -i ... ]

### start
setenv GSIM_INPUT ./gsim.${thick}.${mom}.dat

rm -f ${OUTPUTDIR}/${oname}.hbook
./gsim_barrelveto \
    -ohpss \
    -o ${OUTPUTDIR}/${oname}.hbook \
    -save 0 \
    -rindex ${rindex} \
    -gen ${nev} \
>& ${LOGDIR}/${oname}.log
