// -*- C++ -*-
//
// Uginit.cc
// User routine for GEANT initialization
//
// Author:  Mitsuhiro YAMAGA (yamaga@post.kek.jp)
// Created: Thu Jul 12 15:34:41 JST 2001
//
// $Id: Uginit.cc,v 1.1.1.1 2002/08/13 12:48:08 kensh Exp $
//
// Revision History
//
// $Log: Uginit.cc,v $
// Revision 1.1.1.1  2002/08/13 12:48:08  kensh
//
//
// Start version.
//
//

#include "ccfortran/ccfortran.h"
#include "ccfortran/G321Common.h"
#include "gsim-general/GsimGeneral.h"


////////////////
void
Uginit()
{
  if ( gcflag_.ISWIT[3-1] > 0 )
    std::cerr << "Uginit" << std::endl;

  // GEANT initialization
  GINIT();

  // Data records
  GsimFFuser();
  GsimFFread();

  // Initialize data structure
  GZINIT();
  
  // Initialize graphics
  if ( Display && !isGxsim ){ // Gxsim opens a display by itself.
    HPLINT( 1 );
    GDINIT();
  }

  // Particle table initialization
  GPART();
  GPIONS();

  // Material initialization
  GMATE();

  // Geometry and material description
  Ugeom();

  // Energy loss and cross-section tables
  GPHYSI();

  // Create view bank
  if ( Display ){
    GsimDetView( gcflag_.ISWIT[8-1] );
    IUWK( 0,1 );
  }

}


