// -*- C++ -*- 
//
// ccfortran.h
// CERNLIB interface for C++ code
//
// author  : Mitsuhiro YAMAGA
// created : Sat May 19 17:01:37 JST 2001
//
// $Id: ccfortran.h,v 1.3 2002/09/20 14:31:55 yamaga Exp $
//
// Revision history
//
// $Log: ccfortran.h,v $
// Revision 1.3  2002/09/20 14:31:55  yamaga
// HIGZ/HPLOT functions added.
//
// Revision 1.2  2002/09/03 14:14:52  yamaga
// Another HMERGE added.
//
// Revision 1.1.1.1  2002/08/13 12:48:12  kensh
//
//
// Start version.
//
//

#ifndef CCFORTRAN_H_INCLUDED
#define CCFORTRAN_H_INCLUDED

#include <list>
#include <vector>
#include <string>

// Created from ccfortran.icc by ext_h.pl


//

//////// ZEBRA
inline void
MZEBRA( int mode );
  
inline void
MZPAW( int limit, const std::string& opt );

inline void
RZFILE( int lun, const std::string& dir, const std::string& opt );

inline void
RZOPEN( int lun, char* dir, const std::string& fname, const std::string& opt,
        int lrec, int& stat );

inline void
RZMAKE( int lun, const std::string& dir, int nkey, const std::string& form,
        const std::string& tag, int lrec, const std::string& opt );


//////// HBOOK  
inline void
HBNT( int id, const std::string& title, const std::string& opt );

inline void
HBNAME( int id, const std::string& block, const void* addr, 
        const std::string& form );

inline void
HBOOK1( int hid, const std::string& title, int xbin, float xmin, float xmax ) ;

inline void
HBOOK2( int hid, const std::string& title, 
        int xbin, float xmin, float xmax, int ybin, float ymin, float ymax ) ;

inline void
HBOOKN( int hid, const std::string& title, int nvar,const std::string& dir,
        int nbuf, const std::string& strvars ) ;

inline void
HBOOKN( int hid, const std::string& title, int nvar,const std::string& dir,
        int nbuf, char strvars[][8] ) ;

inline void
HBSET( const std::string& opt, int val, int& err );

inline void
HCDIR( char* dir, int length, const std::string& opt );

inline void
HCDIR( const std::string& dir, const std::string& opt );

inline void
HDELET( int id );

inline bool
HEXIST( int id );

inline void
HFILL( int id, float x, float y, float w );

inline void
HFN( int id, const void* vars );

inline void
HFNOV( int id, float x[] );

inline void
HFNT( int id );

inline void
HFNTB( int id,const std::string& bank );

inline void
HGN( int id, int init, int idevt, void* vars, int& err );

inline void
HGNF( int id, int idevt, void* vars, int& err );

inline void
HGNPAR( int id, const std::string& func );

inline void
HGNT( int id, int idevt, int& err );

inline void
HGNTF( int id, int idevt, int& err );

inline void
HIDALL( int id[], int& n );

inline void
HIDOPT( int id, const std::string& opt );

inline void
HLDIR( const std::string& dir, const std::string& opt );

inline void
HLIMAP( int nwords, const std::string& name );

inline void
HLIMIT( int limit );

inline void
HMERGE( const std::list<std::string>& ifiles, 
        const std::string& ofile );

inline void
HMERGE( const std::vector<std::string>& ifiles, 
        const std::string& ofile );

inline void
HMERGE( int nfiles, const char* ifiles[], const std::string& ofile );

inline void
HNOENT( int hid, int& entries );

inline void
HRECOV( int hid,const std::string& opt );

inline void
HREND( const std::string& dir );

inline void
HRESET( int id, const std::string& title );

inline void
HRGET( int id, const std::string& fname, const std::string& opt );

inline void
HRIN( int hid, int cycle, int offset );

inline void
HROPEN( int lun, const std::string& dir, const std::string& fname, 
        const std::string& opt, int lrec, int& stat );

inline void
HROUT( int id, int& cycle, const std::string& opt );

inline void
HRPUT( int id, const std::string& fname, const std::string& opt );


//////// HPLOT
inline void
HPLEND();

inline void
HPLINT( int n );

inline void
HPLKEY( float x, float y, int sym, const std::string& message );

inline void
HPLOPT( const std::string& opt );

inline void
HPLOPT( const std::string opt[],int n );

inline void
HPLOPT( const std::list<std::string>& opt );

inline void
HPLOPT( const std::vector<std::string>& opt );

inline void
HPLSET( const std::string& opt, float value );


//////// HIGZ
inline void
IACWK( int wkid );

inline void
ICLKS();

inline void
ICLRWK( int wkid, int oflag );

inline void
ICLWK( int wkid );

inline void
IDAWK( int wkid );

inline void
IFA( int npoint, float x_wc[],float y_wc[] );

inline void
IGARC( float x_wc,float y_wc, float rmin,float rmax, 
       float phimin, float phimax );

inline void
IGEND();

inline void
IGINIT( int nwhigz );

inline void
IGLOC( int cursor_type, int* nt, int* button_number,
       float* x_dc, float* y_dc, float* x_wc, float* y_wc );

inline void
IGMETA( int lun, int wktype );

inline void
IGQWK( int wkid,const std::string pname, float* val );

inline void
IGRNG( float xsize, float ysize );

inline void
IGSET( const std::string& opt, float value );

inline void
IGSSE( int errlun, int wktype );

inline void
IGTEXT( float x_wc, float y_wc, const std::string& str,
	float size, float angle, const std::string& opt );

inline void
IML( int n, float x_wc[], float y_wc[] );

inline void
IOPKS( int errlun );

inline void
IOPWK( int wkid, int conid, int wktype );

inline void
IPL( int n, float x_wc[], float y_wc[] );

inline void
IPM( int n, float x_wc[], float y_wc[] );

inline void
ISCR( int wkid,int color_index, float red, float green, float blue );

inline void
ISELNT( int nt );

inline void
ISFACI( int color );

inline void
ISFAIS( int interior );

inline void
ISFASI( int style );

inline void
ISLN( int linetype );

inline void
ISLWSC( float linewidth );

inline void
ISMK( int markertype );

inline void
ISMKSC( float scale );

inline void
ISPLCI( int color );

inline void
ISPMCI( int color );

inline void
ISTXAL( int itx_h, int itx_v );

inline void
ISTXCI( int color );

inline void
ISVP( int nt, float xmin_ndc, float xmax_ndc, float ymin_ndc, float ymax_ndc );

inline void
ISWKVP( int wkid, float xmin_dc, float xmax_dc, float ymin_dc, float ymax_dc );

inline void
ISWKWN( int wkid,float xmin_ndc,float xmax_ndc,float ymin_ndc,float ymax_ndc );

inline void
ISWN( int nt, float xmin_wc, float xmax_wc, float ymin_wc, float ymax_wc );

inline void
ITX( float x_wc,float y_wc, const std::string& str );

inline void
IUWK( int wkid, int oflag );


//////// GEANT
inline void
GDCLOS();

inline void
GDCXYZ();

inline void
GDINIT();

inline void
GDECAY();

inline void
GDOPEN( int view );

inline void
GDRAW( const std::string& name,
       float rotth,float rotph,float rotps, 
       float vx,float vy, float cx, float cy );

inline void
GDRAWC( const std::string& name,
        int view, float dist, float vx,float vy, float cx, float cy );

inline void
GDSHOW( int view );

inline void
GDXYZ( int trak );

inline void
GDZOOM( float zx,float zy, float vx,float vy, float cx,float cy );

inline void
GFKINE( int itra,float vert[3], float pvert[4], int& pid, int& nvtx,
        float ubuf[],int& nubuf );

inline void
GFVERT( int nvtx,float vert[3], int& ntbeam, int& nttarg, float& tofg,
        float ubuf[],int& nubuf );

inline void
GGCLOS();

inline void
GINIT();

inline void
GLAST();

inline void
GMATE();

inline void
GRNDM( float r[], int n );

inline void
GRNDMQ( int& seed1, int& seed2, int& rindex, const std::string& opt );

inline void
GPART();

inline void
GPAW( int nwgean, int nwpaw );

inline void
GPAWPP( int nwgean, int nwpaw );

inline void
GPHYSI();

inline void
GPIONS();

inline void
GPRINT( const std::string& name, int num );

inline void
GSATT( const std::string& name, const std::string& opt, int val );

inline void
GSDK( int pid, float BR[], int mode[] );

inline void
GSKINE( float plab[3], int pid, int nvtx, float ubuf[],
        int nubuf, int& ntrk );

inline void
GSKING( int it );

inline void
GSKINU( int ntrk, int nubuf, float ubuf[], int& iadr );

inline void
GSMIXT( int mate,const std::string& name,float A[], float Z[], float density,
        int nelement, float weight[] );

inline void
GSPOS( const std::string& name, int num, const std::string& mother, 
       float x, float y, float z, int irot, const std::string& only );

inline void
GSPOSP( const std::string& name, int num, const std::string& mother, 
        float x, float y, float z, int irot, const std::string& only,
        float param[], int Nparam );

inline void
GSROTM( int id, float xt, float xp, float yt, float yp, float zt, float zp );

inline void
GSTMED( int med, const std::string& name, int mat, int isvol, int ifield,
        float fieldm, float tmaxfd, float stemax, float deemax, 
        float epsil, float stmin, float ubuf[], int nubuf );

inline void
GSVERT( float vtx[3], int ntbeam, int nttarg, float ubuf[],
        int nubuf, int& nvtx );

inline void
GSVOLU( const std::string& name, const std::string& shape, int mat,
        float param[], int Nparam, int&  ivol );

inline void
GSXYZ();

inline void
GTRACK();

inline void
GTREVE();

inline void
GTRIGI();

inline void
GTRIG();

inline void
GTRIGC();

inline void
GZEBRA( int limit );

inline void
GZINIT();

//////// Other CERNLIB
inline void
FFKEY( const std::string& name,int& var, int size, const std::string& type );

inline void
FFKEY( const std::string& name,int var[], int size, const std::string& type );

inline void
FFKEY( const std::string& name,float& var, int size, const std::string& type );

inline void
FFKEY( const std::string& name,float var[], int size, const std::string& type );


inline void
RANECQ( int& seed1, int& seed2, int& rindex, const std::string& opt );

inline void
RNORMX( float r[],int i, void f( float v[],int* ) );



#include "ccfortran/ccfortran.icc"

#endif // CCFORTRAN_H_INCLUDED

